-- 导出  表 test.mns_account 结构
DROP TABLE IF EXISTS `mns_account`;
CREATE TABLE IF NOT EXISTS `mns_account` (
  `id` bigint NOT NULL AUTO_INCREMENT,
  `name` varchar(256) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL,
  `password` char(32) CHARACTER SET ascii COLLATE ascii_bin NOT NULL,
  `salt` char(4) CHARACTER SET ascii COLLATE ascii_bin NOT NULL,
  `email` varchar(128) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL,
  `area` smallint NOT NULL,
  `phone` bigint NOT NULL,
  `permission` varchar(128) CHARACTER SET ascii COLLATE ascii_bin NOT NULL,
  `disk_usage` bigint NOT NULL,
  `disk_max` bigint NOT NULL,
  `disk_remain` bigint NOT NULL,
  `files` bigint NOT NULL,
  `folders` bigint NOT NULL,
  `ban` tinyint NOT NULL,
  `time_add` bigint NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;

-- 正在导出表  test.mns_account 的数据：~0 rows (大约)
DELETE FROM `mns_account`;

-- 导出  表 test.mns_file_0 结构
DROP TABLE IF EXISTS `mns_file_0`;
CREATE TABLE IF NOT EXISTS `mns_file_0` (
  `id` bigint NOT NULL AUTO_INCREMENT,
  `key` char(40) CHARACTER SET ascii COLLATE ascii_bin NOT NULL,
  `owner` bigint NOT NULL,
  `creator` bigint NOT NULL,
  `parent` char(40) CHARACTER SET ascii COLLATE ascii_bin NOT NULL,
  `name` varchar(128) COLLATE utf8mb4_general_ci NOT NULL,
  `ext` varchar(16) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL COMMENT '小写后缀',
  `text` text CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci,
  `size` bigint NOT NULL COMMENT '文件大小',
  `path` varchar(2048) COLLATE utf8mb4_general_ci NOT NULL,
  `path_key` varchar(2048) CHARACTER SET ascii COLLATE ascii_bin NOT NULL,
  `down` bigint NOT NULL COMMENT '下载次数',
  `visit` bigint NOT NULL COMMENT '访问次数',
  `vfile` char(32) CHARACTER SET ascii COLLATE ascii_bin NOT NULL,
  `url` varchar(256) COLLATE utf8mb4_general_ci NOT NULL COMMENT 'url不为空以本值为准',
  `time_add` bigint NOT NULL,
  `time_edit` bigint NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `key` (`key`) USING BTREE,
  KEY `path` (`path`) USING BTREE,
  KEY `path_key` (`path_key`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;

-- 正在导出表  test.mns_file_0 的数据：~0 rows (大约)
DELETE FROM `mns_file_0`;

-- 导出  表 test.mns_folder_0 结构
DROP TABLE IF EXISTS `mns_folder_0`;
CREATE TABLE IF NOT EXISTS `mns_folder_0` (
  `id` bigint NOT NULL AUTO_INCREMENT,
  `key` char(40) CHARACTER SET ascii COLLATE ascii_bin NOT NULL,
  `owner` bigint NOT NULL,
  `creator` bigint NOT NULL,
  `parent` char(40) CHARACTER SET ascii COLLATE ascii_bin NOT NULL,
  `name` varchar(128) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL,
  `note` varchar(128) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL,
  `size` bigint NOT NULL COMMENT '文件大小',
  `files` bigint NOT NULL,
  `folders` bigint NOT NULL,
  `path` varchar(2048) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL,
  `path_key` varchar(2048) CHARACTER SET ascii COLLATE ascii_bin NOT NULL,
  `time_add` bigint NOT NULL,
  `time_edit` bigint NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `key` (`key`) USING BTREE,
  KEY `path` (`path`) USING BTREE,
  KEY `path_key` (`path_key`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;

-- 正在导出表  test.mns_folder_0 的数据：~0 rows (大约)
DELETE FROM `mns_folder_0`;

-- 导出  表 test.mns_session 结构
DROP TABLE IF EXISTS `mns_session`;
CREATE TABLE IF NOT EXISTS `mns_session` (
  `id` bigint NOT NULL AUTO_INCREMENT,
  `token` char(16) CHARACTER SET ascii COLLATE ascii_bin NOT NULL,
  `data` text CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL,
  `time_update` bigint NOT NULL,
  `time_add` bigint NOT NULL,
  PRIMARY KEY (`id`) USING BTREE,
  UNIQUE KEY `token` (`token`) USING BTREE,
  KEY `time_update` (`time_update`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;

-- 正在导出表  test.mns_session 的数据：~0 rows (大约)
DELETE FROM `mns_session`;

-- 导出  表 test.mns_setting 结构
DROP TABLE IF EXISTS `mns_setting`;
CREATE TABLE IF NOT EXISTS `mns_setting` (
  `id` bigint NOT NULL AUTO_INCREMENT,
  `name` varchar(128) COLLATE utf8mb4_general_ci NOT NULL,
  `value` text COLLATE utf8mb4_general_ci NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=26 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;

-- 正在导出表  test.mns_setting 的数据：~0 rows (大约)
DELETE FROM `mns_setting`;
INSERT INTO `mns_setting` (`id`, `name`, `value`) VALUES
	(1, 'title', 'MAIYUN.NET MNS'),
	(2, 'open', '1'),
	(3, 'footer', 'footer'),
  (4, 'logo', ''),
  (5, 'lang', 'en'),
  (6, 'upload', '0'),
  (7, 'closeinfo', 'Site has been closed.'),
  (8, 'ulang', '0'),
  (9, 'description', ''),
  (10, 'keywords', 'MNS'),
  (11, 'smtp_from', ''),
  (12, 'smtp_pwd', ''),
  (13, 'smtp_user', ''),
  (14, 'smtp_port', '25'),
  (15, 'smtp_server', ''),
  (16, 'smtp_ssl', ''),
  (17, 'smtp_name', ''),
  (18, 'reg', '0'),
  (19, 'reg_disk', '104857600'),
  (20, 'email_verify', '1'),
  (21, 'download', '0'),
  (22, 'downpage', '0'),
  (23, 'fsplit', '1'),
  (24, 'vsplit', '1'),
  (25, 'preview', ''),
  (26, 'introduce', 'Site introduce.');

-- 导出  表 test.mns_vfile_0 结构
DROP TABLE IF EXISTS `mns_vfile_0`;
CREATE TABLE IF NOT EXISTS `mns_vfile_0` (
  `id` bigint NOT NULL AUTO_INCREMENT,
  `key` char(40) CHARACTER SET ascii COLLATE ascii_bin NOT NULL,
  `size` bigint NOT NULL,
  `sha256` char(64) CHARACTER SET ascii COLLATE ascii_bin NOT NULL,
  `server` bigint NOT NULL,
  `path` varchar(256) CHARACTER SET ascii COLLATE ascii_bin NOT NULL,
  `ref` bigint NOT NULL,
  `time_add` bigint NOT NULL,
  PRIMARY KEY (`id`),
  KEY `key` (`key`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;

-- 正在导出表  test.mns_vfile_0 的数据：~0 rows (大约)
DELETE FROM `mns_vfile_0`;