
-- 表：account
DROP TABLE IF EXISTS mns_account;
CREATE TABLE `mns_account` (
  `id` INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
  `name` VARCHAR(256) NOT NULL,
  `password` CHAR(32) NOT NULL,
  `salt` CHAR(4) NOT NULL,
  `email` VARCHAR(128) NOT NULL,
  `area` INTEGER NOT NULL,
  `phone` BIGINT NOT NULL,
  `permission` VARCHAR(128) NOT NULL,
  `disk_usage` BIGINT NOT NULL,
  `disk_max` BIGINT NOT NULL,
  `disk_remain` BIGINT NOT NULL,
  `files` BIGINT NOT NULL,
  `folders` BIGINT NOT NULL,
  `ban` INTEGER NOT NULL,
  `time_add` BIGINT NOT NULL
);

-- 表：file_0
DROP TABLE IF EXISTS mns_file_0;
CREATE TABLE mns_file_0 (id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT, "key" CHAR (40) NOT NULL UNIQUE, owner BIGINT NOT NULL, creator BIGINT, parent CHAR (40) NOT NULL, name VARCHAR (128) NOT NULL, ext VARCHAR (16) NOT NULL, text TEXT, size BIGINT NOT NULL, path VARCHAR (2048) NOT NULL, path_key VARCHAR (2048) NOT NULL, down BIGINT NOT NULL, visit BIGINT NOT NULL, vfile CHAR (32) NOT NULL, url VARCHAR (256) NOT NULL, time_add BIGINT NOT NULL, time_edit BIGINT NOT NULL);

-- 表：folder_0
DROP TABLE IF EXISTS mns_folder_0;
CREATE TABLE mns_folder_0 (id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT, "key" CHAR (40) UNIQUE NOT NULL, owner BIGINT NOT NULL, creator BIGINT, parent CHAR (40) NOT NULL, name VARCHAR (128) NOT NULL, note VARCHAR (128) NOT NULL, size BIGINT NOT NULL, files BIGINT NOT NULL, folders BIGINT NOT NULL, path VARCHAR (2048) NOT NULL, path_key VARCHAR (2048) NOT NULL, time_add BIGINT NOT NULL, time_edit BIGINT NOT NULL);

-- 表：session
DROP TABLE IF EXISTS mns_session;
CREATE TABLE mns_session (id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT, token CHAR (16) UNIQUE NOT NULL, data TEXT NOT NULL, time_update BIGINT NOT NULL, time_add BIGINT NOT NULL);

-- 表：setting
DROP TABLE IF EXISTS mns_setting;
CREATE TABLE `mns_setting` (
  `id` INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
  `name` VARCHAR(128) NOT NULL,
  `value` text NOT NULL
);
INSERT INTO mns_setting (id, name, value) VALUES (1, 'title', 'MAIYUN.NET MNS');
INSERT INTO mns_setting (id, name, value) VALUES (2, 'open', '1');
INSERT INTO mns_setting (id, name, value) VALUES (3, 'footer', 'footer');
INSERT INTO mns_setting (id, name, value) VALUES (4, 'logo', '');
INSERT INTO mns_setting (id, name, value) VALUES (5, 'lang', 'en');
INSERT INTO mns_setting (id, name, value) VALUES (6, 'upload', '0');
INSERT INTO mns_setting (id, name, value) VALUES (7, 'closeinfo', 'Site has been closed.');
INSERT INTO mns_setting (id, name, value) VALUES (8, 'ulang', '0');
INSERT INTO mns_setting (id, name, value) VALUES (9, 'description', '');
INSERT INTO mns_setting (id, name, value) VALUES (10, 'keywords', 'MNS');
INSERT INTO mns_setting (id, name, value) VALUES (11, 'smtp_from', '');
INSERT INTO mns_setting (id, name, value) VALUES (12, 'smtp_pwd', '');
INSERT INTO mns_setting (id, name, value) VALUES (13, 'smtp_user', '');
INSERT INTO mns_setting (id, name, value) VALUES (14, 'smtp_port', '25');
INSERT INTO mns_setting (id, name, value) VALUES (15, 'smtp_server', '');
INSERT INTO mns_setting (id, name, value) VALUES (16, 'smtp_ssl', '');
INSERT INTO mns_setting (id, name, value) VALUES (17, 'smtp_name', '');
INSERT INTO mns_setting (id, name, value) VALUES (18, 'reg', '0');
INSERT INTO mns_setting (id, name, value) VALUES (19, 'reg_disk', '104857600');
INSERT INTO mns_setting (id, name, value) VALUES (20, 'email_verify', '1');
INSERT INTO mns_setting (id, name, value) VALUES (21, 'download', '1');
INSERT INTO mns_setting (id, name, value) VALUES (22, 'downpage', '0');
INSERT INTO mns_setting (id, name, value) VALUES (23, 'fsplit', '1');
INSERT INTO mns_setting (id, name, value) VALUES (24, 'vsplit', '1');
INSERT INTO mns_setting (id, name, value) VALUES (25, 'preview', '');
INSERT INTO mns_setting (id, name, value) VALUES (26, 'introduce', 'Site introduce.');

-- 表：vfile_0
DROP TABLE IF EXISTS mns_vfile_0;
CREATE TABLE mns_vfile_0 (id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT, "key" CHAR (40) NOT NULL, size BIGINT NOT NULL, sha256 CHAR (64) NOT NULL, server BIGINT NOT NULL, path VARCHAR (256) NOT NULL, ref BIGINT NOT NULL, time_add BIGINT NOT NULL);

-- 索引：file_path
DROP INDEX IF EXISTS file_path;
CREATE INDEX file_path ON mns_file_0 (path);

-- 索引：file_path_key
DROP INDEX IF EXISTS file_path_key;
CREATE INDEX file_path_key ON mns_file_0 (path_key);

-- 索引：folder_path
DROP INDEX IF EXISTS folder_path;
CREATE INDEX folder_path ON mns_folder_0 (path);

-- 索引：folder_path_key
DROP INDEX IF EXISTS folder_path_key;
CREATE INDEX folder_path_key ON mns_folder_0 (path_key);

-- 索引：vfile_key
DROP INDEX IF EXISTS vfile_key;
CREATE INDEX vfile_key ON mns_vfile_0 ("key");

-- 索引：session_time_update
DROP INDEX IF EXISTS session_time_update;
CREATE INDEX session_time_update ON mns_session (time_update);
