"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const tool = __importStar(require("../../tool"));
let vroot;
const xhr = new XMLHttpRequest();
xhr.upload.onprogress = function (e) {
    vroot.upFiles[0].per = Math.round((e.loaded / e.total) * 100).toString();
};
xhr.onload = function () {
    try {
        const j = JSON.parse(xhr.response);
        if (j.result <= 0) {
            alert(j.msg);
            vroot.upFiles.splice(0, 1);
            vroot.uploadHandler();
            return;
        }
        vroot.refresh();
        vroot.upFiles.splice(0, 1);
        vroot.uploadHandler();
    }
    catch (_a) {
        vroot.upFiles.splice(0, 1);
        vroot.uploadHandler();
    }
};
xhr.onerror = function () {
    vroot.upFiles.splice(0, 1);
    vroot.uploadHandler();
};
const globalConst = window.globalConst;
const app = Vue.createApp({
    'data': function () {
        return {
            'mask': false,
            'maskt': false,
            'rightMenuShow': false,
            'itemMenuShow': false,
            'dialogType': '',
            'folderName': '',
            'folderNote': '',
            'dialogTxt': '',
            'stype': '',
            'skey': '',
            'fileDrag': false,
            'files': [],
            'upFiles': [],
            'mlist': [],
            'mpath': [],
            'mpathKey': [],
            'account': '',
            'user': '',
            'password': '',
            'captcha': '',
            'captchaImg': '',
            'list': [],
            'path': [],
            'pathKey': []
        };
    },
    'methods': {
        openMenu: function (e) {
            return __awaiter(this, void 0, void 0, function* () {
                if (this.rightMenuShow) {
                    return;
                }
                if (this.account === '') {
                    this.mask = true;
                    const r = yield fetch(globalConst.urlBase + 'api/zuny/checkLogin');
                    const j = yield r.json();
                    this.account = j.account;
                    this.mask = false;
                }
                const rect = this.$refs.add.getBoundingClientRect();
                this.$refs.rightMenu.style.right = window.innerWidth - rect.x - rect.width + 'px';
                this.$refs.rightMenu.style.top = (rect.y + rect.height + 10) + 'px';
                this.rightMenuShow = true;
            });
        },
        hideMenu: function () {
            if (this.rightMenuShow) {
                this.rightMenuShow = false;
            }
            if (this.itemMenuShow) {
                this.itemMenuShow = false;
            }
        },
        createFolder: function () {
            if (!this.account) {
                this.login();
                return;
            }
            this.dialogType = 'folder';
            this.folderName = '';
            this.folderNote = '';
            this.hideMenu();
        },
        upload: function () {
            if (!this.account) {
                this.login();
                return;
            }
            this.dialogType = 'upload';
            this.hideMenu();
            this.files.length = 0;
        },
        fileDragEnter: function (e) {
            e.preventDefault();
            this.fileDrag = true;
        },
        fileDragLeave: function (e) {
            e.preventDefault();
            this.fileDrag = false;
        },
        fileDrop: function (e) {
            var _a;
            e.preventDefault();
            this.fileDrag = false;
            if (!((_a = e.dataTransfer) === null || _a === void 0 ? void 0 : _a.files)) {
                return;
            }
            for (const file of e.dataTransfer.files) {
                if (this.files.length >= 10) {
                    break;
                }
                this.files.push(file);
            }
        },
        fileChange: function () {
            if (!this.$refs.file.files.length) {
                return;
            }
            const files = this.$refs.file.files;
            for (let i = 0; i < files.length; ++i) {
                if (this.files.length >= 10) {
                    break;
                }
                this.files.push(files[i]);
            }
            this.$refs.file.value = '';
        },
        toUpload: function () {
            this.dialogType = '';
            for (const item of this.files) {
                this.upFiles.push({
                    'name': item.name,
                    'file': item,
                    'per': '0'
                });
            }
            if (this.upFiles.length === this.files.length) {
                this.uploadHandler();
            }
        },
        uploadHandler: function () {
            if (!this.upFiles.length) {
                return;
            }
            const fd = new FormData();
            fd.append('parent', globalConst.parent);
            fd.append('file', this.upFiles[0].file);
            fd.append('_xsrf', globalConst.xsrf);
            xhr.open('POST', globalConst.urlBase + 'api/zuny/upload', true);
            xhr.send(fd);
        },
        create: function () {
            return __awaiter(this, void 0, void 0, function* () {
                this.mask = true;
                this.dialogType = '';
                const r = yield tool.post(globalConst.urlBase + 'api/zuny/createFolder', {
                    'name': this.folderName,
                    'note': this.folderNote,
                    'parent': globalConst.parent,
                    '_xsrf': globalConst.xsrf
                });
                const j = yield r.json();
                if (j.result <= 0) {
                    this.mask = false;
                    this.dialogType = 'dialog';
                    this.dialogTxt = j.msg;
                    return;
                }
                this.mask = false;
                this.refresh();
            });
        },
        refresh: function (parent, push) {
            return __awaiter(this, void 0, void 0, function* () {
                if (parent === undefined) {
                    parent = globalConst.parent;
                }
                if (push === undefined) {
                    push = true;
                }
                this.maskt = true;
                try {
                    const r = yield tool.post(globalConst.urlBase + 'api/zuny/getList', {
                        'parent': parent
                    });
                    const j = yield r.json();
                    if (j.result <= 0) {
                        this.maskt = false;
                        this.dialogType = 'dialog';
                        this.dialogTxt = j.msg;
                        return;
                    }
                    this.maskt = false;
                    globalConst.parent = j.parent;
                    this.path = j.path;
                    this.pathKey = j.pathKey;
                    this.list = j.list;
                    document.title = j.title + ' - Powered by Zuny';
                    if (push) {
                        window.history.pushState({
                            'key': j.parent
                        }, j.title + ' - Powered by Zuny', globalConst.urlBase + (j.parent ? 'folder/' + j.parent : ''));
                    }
                }
                catch (_a) {
                    this.maskt = false;
                    this.dialogType = 'dialog';
                    this.dialogTxt = 'Network error.';
                }
            });
        },
        go: function (e, key) {
            return __awaiter(this, void 0, void 0, function* () {
                e.preventDefault();
                this.refresh(key);
            });
        },
        login: function () {
            this.hideMenu();
            if (this.account) {
                this.dialogType = 'logout';
                return;
            }
            this.dialogType = 'login';
            this.user = '';
            this.password = '';
            this.captcha = '';
            this.reCaptcha();
        },
        reCaptcha: function () {
            this.captchaImg = globalConst.urlBase + 'api/zuny/captcha?' + Math.random();
        },
        move: function () {
            this.moveRefresh();
            this.dialogType = 'move';
            this.hideMenu();
        },
        toMove: function () {
            return __awaiter(this, void 0, void 0, function* () {
                this.mask = true;
                this.dialogType = '';
                const r = yield tool.post(globalConst.urlBase + 'api/zuny/move', {
                    'key': this.skey,
                    'type': this.stype,
                    'to': this.mpathKey.length ? this.mpathKey[this.mpathKey.length - 1] : '',
                    '_xsrf': globalConst.xsrf
                });
                const j = yield r.json();
                if (j.result <= 0) {
                    this.mask = false;
                    this.dialogType = 'dialog';
                    this.dialogTxt = j.msg;
                    return;
                }
                this.mask = false;
                this.refresh();
            });
        },
        moveRefresh: function (parent = '') {
            return __awaiter(this, void 0, void 0, function* () {
                this.maskt = true;
                try {
                    const r = yield tool.post(globalConst.urlBase + 'api/zuny/getList', {
                        'parent': parent,
                        'file': '0'
                    });
                    const j = yield r.json();
                    if (j.result <= 0) {
                        this.maskt = false;
                        this.dialogType = 'dialog';
                        this.dialogTxt = j.msg;
                        return;
                    }
                    this.maskt = false;
                    this.mpath = j.path;
                    this.mpathKey = j.pathKey;
                    this.mlist = j.list;
                }
                catch (_a) {
                    this.maskt = false;
                    this.dialogType = 'dialog';
                    this.dialogTxt = 'Network error.';
                }
            });
        },
        toLogin: function () {
            return __awaiter(this, void 0, void 0, function* () {
                this.mask = true;
                this.dialogType = '';
                const r = yield tool.post(globalConst.urlBase + 'api/zuny/login', {
                    'name': this.user,
                    'password': this.password,
                    'captcha': this.captcha,
                    '_xsrf': globalConst.xsrf
                });
                const j = yield r.json();
                if (j.result <= 0) {
                    this.mask = false;
                    this.dialogType = 'dialog';
                    this.dialogTxt = j.msg;
                    return;
                }
                this.mask = false;
                this.account = j.account;
            });
        },
        toLogout: function () {
            return __awaiter(this, void 0, void 0, function* () {
                this.mask = true;
                this.dialogType = '';
                yield fetch(globalConst.urlBase + 'api/zuny/logout');
                this.mask = false;
                this.account = false;
            });
        },
        openItemMenu: function (el, type, name, note, key) {
            return __awaiter(this, void 0, void 0, function* () {
                if (this.itemMenuShow) {
                    return;
                }
                if (this.account === '') {
                    this.mask = true;
                    const r = yield fetch(globalConst.urlBase + 'api/zuny/checkLogin');
                    const j = yield r.json();
                    this.account = j.account;
                    this.mask = false;
                }
                if (!this.account) {
                    this.login();
                    return;
                }
                this.stype = type;
                this.skey = key;
                this.folderName = name;
                this.folderNote = note;
                const rect = el.getBoundingClientRect();
                this.$refs.itemMenu.style.left = rect.x + 'px';
                this.$refs.itemMenu.style.top = (rect.y + rect.height + 10) + 'px';
                this.itemMenuShow = true;
            });
        },
        rename: function () {
            this.dialogType = 'rename';
            this.hideMenu();
        },
        toRename: function () {
            return __awaiter(this, void 0, void 0, function* () {
                this.mask = true;
                this.dialogType = '';
                const r = yield tool.post(globalConst.urlBase + 'api/zuny/rename', {
                    'key': this.skey,
                    'name': this.folderName,
                    'note': this.folderNote,
                    'type': this.stype,
                    '_xsrf': globalConst.xsrf
                });
                const j = yield r.json();
                if (j.result <= 0) {
                    this.mask = false;
                    this.dialogType = 'dialog';
                    this.dialogTxt = j.msg;
                    return;
                }
                this.mask = false;
                this.refresh();
            });
        },
        remove: function () {
            this.dialogType = 'remove';
            this.hideMenu();
        },
        toRemove: function () {
            return __awaiter(this, void 0, void 0, function* () {
                this.mask = true;
                this.dialogType = '';
                const r = yield tool.post(globalConst.urlBase + 'api/zuny/remove', {
                    'key': this.skey,
                    'type': this.stype,
                    '_xsrf': globalConst.xsrf
                });
                const j = yield r.json();
                if (j.result <= 0) {
                    this.mask = false;
                    this.dialogType = 'dialog';
                    this.dialogTxt = j.msg;
                    return;
                }
                this.mask = false;
                this.refresh();
            });
        }
    },
    mounted: function () {
        return __awaiter(this, void 0, void 0, function* () {
            this.list = globalConst.list;
            this.path = globalConst.path;
            this.pathKey = globalConst.pathKey;
            vroot = this;
            if (!document.body.innerHTML.includes('https://www.maiyun.net/zuny')) {
                document.body.insertAdjacentHTML('beforeend', '<div style="position:fixed;font-size:12px;right:0;bottom:0;color:rgba(0,0,0,.4);">P' + 'owered by <a href="https://www.maiyun.net" target="_blank">MAIYUN.NET</a> <a href="https://www.maiyun.net/zuny" target="_blank">Zuny</a></div>');
            }
            yield this.$nextTick();
            const menus = document.querySelectorAll('.menu');
            for (const menu of menus) {
                menu.addEventListener('mousedown', (e) => {
                    e.stopPropagation();
                });
            }
        });
    }
});
const ls = document.querySelectorAll('.removed');
for (const item of ls) {
    item.remove();
}
app.mount('#panel');
document.addEventListener('mousedown', function () {
    vroot.hideMenu();
});
window.addEventListener('popstate', function (e) {
    var _a, _b;
    vroot.refresh((_b = (_a = e.state) === null || _a === void 0 ? void 0 : _a.key) !== null && _b !== void 0 ? _b : '', false);
});
