<!DOCTYPE HTML>
<html class="<?php echo PRODUCT ?>">
<head>
<title><?php echo PRODUCT_W ?> <?php echo PVERSION ?> installer - MAIYUN.NET</title>
<meta http-equiv="content-type" content="text/html;charset=utf-8">
<meta name="viewport" content="width=device-width,initial-scale=1,minimum-scale=1,maximum-scale=1,user-scalable=no">
<script src="<?php echo STATIC_PATH ?>cdn/npm/vue@3.2.47/dist/vue.global.prod.min.js"></script>
<script src="<?php echo STATIC_PATH ?>cdn/npm/@litert/loader@3.4.10/dist/loader.min.js?path=<?php echo STATIC_PATH ?>install/main.js&after=?<?php echo STATIC_VER ?>"></script>
<script>
window.globalConst = {
    'urlBase': '<?php echo URL_BASE ?>'
};
</script>
<link href="<?php echo STATIC_PATH ?>main.css?<?php echo STATIC_VER ?>" rel="stylesheet">
<link href="<?php echo STATIC_PATH ?>install/main.css?<?php echo STATIC_VER ?>" rel="stylesheet">
</head>
<body>
<div id="panel" class="wrap">
    <div class="win">
        <!-- 首屏 -->
        <div class="panel index" :class="[(panel === 'index') && 'show']">
            <div style="text-align: center;">
                <img src="<?php echo STATIC_PATH ?>img/zuny-color.png?<?php echo STATIC_VER ?>" width="150">
                <div style="margin-top: 20px; font-size: 18px;">v<?php echo PVERSION ?> <?php echo ucwords(EDITION) ?></div>
                <select v-model="lang" class="button" style="margin-top: 40px;">
                    <option value="en">English</option>
                    <option value="sc">简体中文</option>
                    <option value="tc">繁體中文</option>
                    <option value="ja">日本語</option>
                    <option value="ko">한국어</option>
                    <option value="th">ภาษาไทย</option>         <!-- 泰语 -->
                    <option value="es">Español</option>         <!-- 西语 -->
                    <option value="de">Deutsch</option>         <!-- 德语 -->
                    <option value="fr">Français</option>        <!-- 法语 -->
                    <option value="pt">Português</option>       <!-- 葡语 -->
                    <option value="ru">Русский</option>         <!-- 俄语 -->
                    <option value="vi">Tiếng việt</option>      <!-- 越语 -->
                </select>
                <div @click="start" class="button color" style="margin-top: 20px;">{{langs[lang]['start']}}</div>
            </div>
        </div>
        <!-- 授权协议 -->
        <div class="panel license" :class="[(panel === 'license') && 'show']">
            <div style="flex: 1; overflow: auto;" v-html="license" class="textbox"></div>
            <div class="buttons" style="margin-top: 20px;">
                <div class="button" @click="back">{{langs[lang]['back']}}</div>
                <div class="button" @click="reject">{{langs[lang]['reject']}}</div>
                <div class="button color" @click="accept">{{langs[lang]['accept']}}</div>
            </div>
        </div>
        <!-- 检查目录权限 -->
        <div class="panel permission" :class="[(panel === 'permission') && 'show']">
            <div style="flex: 1; overflow: auto;" class="textbox">
                <template v-for="item, name of permissions">
                    <div v-if="name === 'folder'">
                        <div>{{langs[lang]['permission-folder']}}:</div>
                        <div v-for="val, path of item" class="line">
                            <div>{{path}}</div>
                            <div>...</div>
                            <div :class="[val ? 'true' : 'false']">{{langs[lang][(val ? '' : 'un') + 'available']}}</div>
                        </div>
                    </div>
                    <div v-else-if="name === 'function'" style="margin-top: 30px;">
                        <div>{{langs[lang]['permission-function']}}:</div>
                        <div v-for="val, name of item" class="line">
                            <div>{{name}}</div>
                            <div>...</div>
                            <div :class="[val ? 'true' : 'false']">{{langs[lang][(val ? '' : 'un') + 'available']}}</div>
                        </div>
                    </div>
                    <div v-else-if="name === 'class'" style="margin-top: 30px;">
                        <div>{{langs[lang]['permission-class']}}:</div>
                        <div v-for="val, name of item" class="line">
                            <div>{{name}}</div>
                            <div>...</div>
                            <div :class="[val ? 'true' : 'false']">{{langs[lang][(val ? '' : 'un') + 'available']}}</div>
                        </div>
                    </div>
                    <div v-else-if="name === 'existdir'" style="margin-top: 30px;">
                        <div>{{langs[lang]['permission-existdir']}}:</div>
                        <div v-for="val, name of item" class="line">
                            <div>{{name}}</div>
                            <div>...</div>
                            <div :class="[val ? 'true' : 'false']">{{langs[lang][(val ? '' : 'un') + 'available']}}</div>
                        </div>
                    </div>
                    <div v-else-if="name === 'existfile'" style="margin-top: 30px;">
                        <div>{{langs[lang]['permission-existfile']}}:</div>
                        <div v-for="val, name of item" class="line">
                            <div>{{name}}</div>
                            <div>...</div>
                            <div :class="[val ? 'true' : 'false']">{{langs[lang][(val ? '' : 'un') + 'available']}}</div>
                        </div>
                    </div>
                    <div v-else style="margin-top: 30px;">
                        <div>{{langs[lang]['permission-other']}}:</div>
                        <div v-for="val, name of item" class="line">
                            <div>{{name}}</div>
                            <div>...</div>
                            <div :class="[val ? 'true' : 'false']">{{langs[lang][(val ? '' : 'un') + 'available']}}</div>
                        </div>
                    </div>
                </template>
            </div>
            <div class="buttons" style="margin-top: 20px;">
                <div class="button" @click="back">{{langs[lang]['back']}}</div>
                <div class="button" @click="permission">{{langs[lang]['recheck']}}</div>
                <div class="button color" :class="[permissionsTrue ? '' : 'disabled']" @click="next">{{langs[lang]['next']}}</div>
            </div>
        </div>
        <!-- 数据库 -->
        <div class="panel form db" :class="[(panel === 'db') && 'show']">
            <div>
                <div class="line">
                    <div class="title">{{langs[lang]['database']}}:</div>
                    <select class="button" v-model="dbtype">
                        <option value="sqlite">SQLite</option>
                        <?php if (EDITION_NUM > 0) { ?><option value="mysql">MySQL</option><?php } ?>
                    </select>
                </div>
                <template v-if="dbtype === 'sqlite'">
                    <div class="line">
                        <div class="title">{{langs[lang]['address']}}:</div>
                        <div>data/db/db.sqlite</div>
                    </div>
                </template>
                <template v-else>
                    <div class="line">
                        <div class="title">{{langs[lang]['address']}}:</div>
                        <input v-model="address" class="textbox" placeholder="192.168.1.1" />
                    </div>
                </template>
                <div class="line">
                    <div class="title">{{langs[lang]['table-prefix']}}:</div>
                    <input v-model="pre" class="textbox" />
                </div>
            </div>
            <div class="buttons" style="margin-top: 20px;">
                <div class="button" @click="back">{{langs[lang]['back']}}</div>
                <div class="button color" @click="next">{{langs[lang]['next']}}</div>
            </div>
        </div>
        <!-- 准备好了 -->
        <div class="panel ready" :class="[(panel === 'ready') && 'show']">
            <div>
                {{langs[lang]['it-is-ready']}}
            </div>
            <div class="buttons" style="margin-top: 20px;">
                <div class="button" @click="back">{{langs[lang]['back']}}</div>
                <div class="button color" @click="install">{{langs[lang]['install']}}</div>
            </div>
        </div>
        <!-- 安装屏 -->
        <div class="panel install" :class="[(panel === 'install') && 'show']">
            <div class="textbox">
                <div v-for="line of installTxt">{{line}}</div>
            </div>
        </div>
        <!-- 设置屏幕 -->
        <div class="panel form setting" :class="[(panel === 'setting') && 'show']">
            <div>
                <div>{{langs[lang]['setting-note']}}</div>
                <div class="line">
                    <div class="title">{{langs[lang]['name']}}:</div>
                    <input v-model="name" class="textbox" />
                </div>
                <div class="line">
                    <div class="title">{{langs[lang]['password']}}:</div>
                    <input v-model="password" class="textbox" />
                </div>
                <div class="line">
                    <div class="title">{{langs[lang]['email']}}:</div>
                    <input v-model="email" class="textbox" />
                </div>
                <div class="line">
                    <div class="title">{{langs[lang]['phone']}}:</div>
                    <input v-model="area" class="textbox" placeholder="86" style="width: 50px;" />
                    <input v-model="phone" class="textbox" placeholder="181xxx" style="width: 80px; margin-left: 10px;" />
                </div>
                <div class="line">
                    <div class="title">{{langs[lang]['site-name']}}:</div>
                    <input v-model="sitename" class="textbox" />
                </div>
            </div>
            <div class="buttons" style="margin-top: 20px;">
                <div class="button color" @click="next">{{langs[lang]['next']}}</div>
            </div>
        </div>
        <!-- 用户体验改善计划 -->
        <div class="panel form improvement" :class="[(panel === 'improvement') && 'show']">
            <div>
                <div style="text-align: center; font-weight: bold;">{{langs[lang]['improvement-title']}}</div>
                <div style="margin-top: 10px; text-indent: 28px; width: 100%;">{{langs[lang]['improvement-1']}}</div>
                <div style="margin-top: 10px; text-indent: 28px; width: 100%;">{{langs[lang]['improvement-2']}}</div>
                <div style="margin-top: 10px; text-indent: 28px; width: 100%;">{{langs[lang]['improvement-3']}}</div>
                <div class="line">
                    <div class="title">QQ:</div>
                    <input v-model="qq" class="textbox" />
                </div>
                <div class="line">
                    <div class="title">{{langs[lang]['email']}}:</div>
                    <input v-model="email" class="textbox" />
                </div>
                <div class="line">
                    <div class="title">{{langs[lang]['phone']}}:</div>
                    <input v-model="area" class="textbox" placeholder="86" style="width: 50px;" />
                    <input v-model="phone" class="textbox" placeholder="181xxx" style="width: 80px; margin-left: 10px;" />
                </div>
            </div>
            <div class="buttons" style="margin-top: 20px;">
                <div class="button color" @click="next">{{langs[lang]['next']}}</div>
            </div>
        </div>
        <!-- 结束 -->
        <div class="panel finish" :class="[(panel === 'finish') && 'show']">
            <div style="text-align: center;">
                <img src="<?php echo STATIC_PATH ?>img/zuny-color.png?<?php echo STATIC_VER ?>" width="150">
                <div style="margin-top: 20px; font-size: 18px;">v<?php echo PVERSION ?> <?php echo ucwords(EDITION) ?></div>
                <div style="margin-top: 20px;">QQ Group: 120857714</div>
                <div style="margin-top: 20px;">Telegram: <a href="https://t.me/maiyunnet" target="_blank">Join group</a></div>
                <div @click="finish" class="button color" style="margin-top: 20px;">{{langs[lang]['finish']}}</div>
            </div>
        </div>
        <div class="mask" :class="[mask && 'show']"><div></div></div>
    </div>
</div>
</body>
</html>