<!DOCTYPE HTML>
<html class="zuny">
<head>
<title><?php echo $title ?> - Powered by <?php echo PRODUCT_W ?></title>
<meta http-equiv="content-type" content="text/html;charset=utf-8">
<meta name="viewport" content="width=device-width,initial-scale=1,minimum-scale=1,maximum-scale=1,user-scalable=no">
<?php if ($keywords) { ?>
<meta name="keywords" content="<?php echo $keywords ?>">
<?php } ?>
<?php if ($description) { ?>
<meta name="description" content="<?php echo $description ?>">
<?php } ?>
<script src="<?php echo STATIC_PATH ?>cdn/npm/vue@3.2.47/dist/vue.global.prod.min.js"></script>
<script src="<?php echo STATIC_PATH ?>cdn/npm/@litert/loader@3.4.10/dist/loader.min.js?path=<?php echo STATIC_PATH ?>zuny/folder/main.js&after=?<?php echo STATIC_VER ?>"></script>
<script>
window.globalConst = {
    'urlBase': '<?php echo URL_BASE ?>',
    'xsrf': '<?php echo $xsrf ?>',
    'parent': '<?php echo $parent ?>',
    'path': <?php echo json_encode($path) ?>,
    'pathKey': <?php echo json_encode($pathKey) ?>,
    'list': <?php echo json_encode($list) ?>
};
</script>
<link href="<?php echo STATIC_PATH ?>main.css?<?php echo STATIC_VER ?>" rel="stylesheet">
<link href="<?php echo STATIC_PATH ?>zuny/folder/main.css?<?php echo STATIC_VER ?>" rel="stylesheet">
<?php if ($open === 0) { ?>
<style>
html, body, #panel {height: 100%;}
#panel {display: flex; flex-direction: column;}
</style>
<?php } ?>
</head>
<body>
<div id="panel">
    <!-- 遮罩 -->
    <div class="mask o" :class="[mask && 'show']"><div></div></div>
    <div class="mask t" :class="[maskt && 'show']"></div>
    <!-- 窗体 -->
    <div class="dialog" :class="[dialogType && 'show']">
        <div class="content">
            <div class="body">
                <template v-if="dialogType === 'folder'">
                    <!-- 创建文件夹 -->
                    <div style="text-align: center;"><?php echo l('create-folder') ?></div>
                    <input class="textbox" style="margin-top: 20px;" v-model="folderName" placeholder="<?php echo l('name') ?>" />
                    <input class="textbox" style="margin-top: 20px;" v-model="folderNote" placeholder="<?php echo l('description') ?>" />
                </template>
                <template v-else-if="dialogType === 'upload'">
                    <!-- 上传文件 -->
                    <div class="selectfile" :class="[fileDrag && 'drag']" @dragenter="fileDragEnter" @dragleave="fileDragLeave" @drop="fileDrop" @dragover="$event.preventDefault()">
                        <div v-if="!files.length" class="box" @click="$refs.file.click()"><?php echo l('select-file') ?></div>
                        <div v-else class="fbox">
                            <div>
                                <div v-for="item, i of files" class="fileitem">
                                    <div>{{item.name}}</div>
                                    <a href="javascript:void(0);" @click="files.splice(i, 1)"><?php echo l('remove') ?></a>
                                </div>
                                <div style="text-align: center;">
                                    <a href="javascript:void(0);" @click="$refs.file.click()"><?php echo l('add-file') ?></a>
                                </div>
                            </div>
                        </div>
                        <input type="file" ref="file" multiple @change="fileChange">
                    </div>
                </template>
                <template v-else-if="dialogType === 'move'">
                    <!-- 移动文件/文件夹 -->
                    <!-- 地址栏 -->
                    <div class="path" :class="[maskt && 'progress']">
                        <a class="item" href="javascript:void(0);" @click="moveRefresh()"><?php echo l('file') ?></a>
                        <a v-for="item, i of mpath" class="item" href="javascript:void(0);" @click="moveRefresh(mpathKey[i])">{{item}}</a>
                    </div>
                    <!-- 列表 -->
                    <div style="padding: 0 20px 20px 20px; overflow-y: auto; max-height: 300px;" :class="[maskt && 'progress']">
                        <div v-for="item of mlist" class="table-item">
                            <div>
                                <div>
                                    <img src="<?php echo STATIC_PATH ?>img/folder.svg" width="28" /><a href="javascript:void(0);" @click="moveRefresh(item.key)">{{item.name}}</a>
                                </div>
                            </div>
                        </div>
                    </div>
                </template>
                <template v-else-if="dialogType === 'rename'">
                    <!-- 重命名文件/文件夹 -->
                    <div style="text-align: center;">{{stype === 'folder' ? '<?php echo l('rename-folder') ?>' : '<?php echo l('rename-file') ?>'}}</div>
                    <input class="textbox" style="margin-top: 20px;" v-model="folderName" />
                    <input class="textbox" style="margin-top: 20px;" v-model="folderNote" />
                </template>
                <template v-else-if="dialogType === 'remove'">
                    <div><?php echo l('remove-confirm') ?></div>
                </template>
                <template v-else-if="dialogType === 'dialog'">
                    <div>{{dialogTxt}}</div>
                </template>
                <template v-else-if="dialogType === 'login'">
                    <input class="textbox" v-model="user" placeholder="<?php echo l('user') ?>" />
                    <input class="textbox" v-model="password" placeholder="<?php echo l('password') ?>" type="password" style="margin-top: 20px;" />
                    <div style="display: flex; margin-top: 20px; align-items: center;">
                        <input class="textbox" v-model="captcha" style="flex: 1; width: 0;" />
                        <img @click="reCaptcha" height="45" width="120" :src="captchaImg" style="margin-left: 10px; cursor: pointer; border-radius: 5px;" />
                    </div>
                </template>
                <template v-else-if="dialogType === 'logout'">
                    <div><?php echo l('logout-confirm') ?></div>
                </template>
            </div>
            <div class="buttons" style="padding: 20px;">
                <div class="button" @click="dialogType = ''"><?php echo l('cancel') ?></div>
                <div v-if="dialogType === 'folder'" class="button color" @click="create"><?php echo l('create') ?></div>
                <div v-else-if="dialogType === 'upload'" class="button color" :class="[!files.length && 'disabled']" @click="toUpload"><?php echo l('upload') ?></div>
                <div v-else-if="dialogType === 'move'" class="button color" @click="toMove"><?php echo l('move here') ?></div>
                <div v-else-if="dialogType === 'login'" class="button color" @click="toLogin"><?php echo l('login') ?></div>
                <div v-else-if="dialogType === 'logout'" class="button color" @click="toLogout"><?php echo l('logout') ?></div>
                <div v-else-if="dialogType === 'rename'" class="button color" @click="toRename"><?php echo l('rename') ?></div>
                <div v-else-if="dialogType === 'remove'" class="button color" @click="toRemove"><?php echo l('remove') ?></div>
            </div>
        </div>
    </div>
    <!-- 页面 -->
    <div class="header">
        <img src="<?php echo $logo ? (STATIC_PATH . 'files/' . $logo) : (STATIC_PATH . 'img/zuny-color.png') ?>" width="100" />
        <!-- 右上角按钮 -->
        <div class="add" ref="add" @click="openMenu">
            <svg width="24" height="24" viewBox="0 0 24 24"><path d="m12.75 5c0-.41421-.3358-.75-.75-.75s-.75.33579-.75.75v6.25h-6.25c-.41421 0-.75.3358-.75.75s.33579.75.75.75h6.25v6.25c0 .4142.3358.75.75.75s.75-.3358.75-.75v-6.25h6.25c.4142 0 .75-.3358.75-.75s-.3358-.75-.75-.75h-6.25z" /></svg>
        </div>
        <!-- 右上角菜单 -->
        <div class="menu" :class="[rightMenuShow && 'show']" ref="rightMenu">
            <?php if ($open === 1) { ?>
            <div class="item" @click="createFolder">
                <svg width="22" height="22" viewBox="0 0 24 24"><path d="m9.53018 5.7541c-.06247-.00377-.13175-.0041-.33296-.0041h-1.39722c-.85245 0-1.44669.00059-1.90932.03838-.45387.03709-.71464.10622-.91216.20686-.42336.21571-.76757.55992-.98328.98328-.10064.19752-.16977.45829-.20686.91216-.0378.46263-.03838 1.05687-.03838 1.90932v4.4c0 .8525.00058 1.4467.03838 1.9093.03709.4539.10622.7147.20686.9122.21571.4233.55992.7676.98328.9833.19752.1006.45829.1697.91216.2068.46263.0378 1.05687.0384 1.90932.0384h8.4c.8525 0 1.4467-.0006 1.9093-.0384.4539-.0371.7147-.1062.9122-.2068.4233-.2157.7675-.56.9833-.9833.1006-.1975.1697-.4583.2068-.9122.0378-.4626.0384-1.0568.0384-1.9093v-1.4c0-.8525-.0006-1.4467-.0384-1.9093-.0371-.4539-.1062-.7147-.2068-.91218-.2158-.42336-.56-.76757-.9833-.98328-.1975-.10064-.4583-.16977-.9122-.20686-.4626-.03779-1.0568-.03838-1.9093-.03838h-1.3972-.0227c-.1701.00002-.2874.00003-.4008-.00683-1.0926-.06603-2.1018-.60614-2.7628-1.4786-.0686-.09055-.1336-.18814-.228-.32973l-.0125-.01881c-.1116-.16742-.1503-.22488-.1881-.27477-.3966-.52347-1.0022-.84754-1.65772-.88716zm-.31031-1.5041h.00004c.17013-.00001.28739-.00002.40076.00683 1.09263.06603 2.10183.60614 2.76283 1.47861.0686.09052.1336.18809.2279.32964l.0001.00009.0125.01881c.1116.16741.1503.22488.1881.27476.3966.52348 1.0022.84755 1.6577.88716.0625.00378.1318.0041.333.0041h1.3972.0321c.8128 0 1.4685-.00001 1.9994.04337.5466.04466 1.0267.13902 1.471.36536.7056.35952 1.2792.9332 1.6388 1.63881.2263.44422.3207.92436.3653 1.47096.0434.5309.0434 1.1865.0434 1.9994v.0321 1.4.0321c0 .8129 0 1.4685-.0434 1.9994-.0446.5466-.139 1.0267-.3653 1.471-.3596.7056-.9332 1.2793-1.6388 1.6388-.4443.2263-.9244.3207-1.471.3653-.5309.0434-1.1865.0434-1.9994.0434h-.0321-8.4-.03212c-.81283 0-1.46844 0-1.99935-.0434-.54663-.0446-1.02678-.139-1.47099-.3653-.70561-.3595-1.27929-.9332-1.63881-1.6388-.22634-.4443-.3207-.9244-.36537-1.471-.04337-.5309-.04337-1.1865-.04336-1.9994v-.0321-4.4-.0321-.00001c-.00001-.81284-.00001-1.46845.04336-1.99935.04467-.54664.13903-1.02678.36537-1.471.35952-.70561.9332-1.27929 1.63881-1.63881.44421-.22634.92436-.3207 1.47099-.36536.53089-.04338 1.18648-.04337 1.99928-.04337h.00009.0321 1.39722zm-.96987 8.75c0-.4142.33579-.75.75-.75h2.25v-2.25c0-.41421.3358-.75.75-.75s.75.33579.75.75v2.25h2.25c.4142 0 .75.3358.75.75s-.3358.75-.75.75h-2.25v2.25c0 .4142-.3358.75-.75.75s-.75-.3358-.75-.75v-2.25h-2.25c-.41421 0-.75-.3358-.75-.75z" /></svg>
                <div><?php echo l('create-folder') ?></div>
            </div>
            <div class="item" @click="upload">
                <svg width="22" height="22" viewBox="0 0 24 24"><path d="m10.7322 5.08057c.8196-.2944 1.716-.2944 2.5356 0 .5204.18694.9553.52193 1.3962.95466.4304.42245.9187.9921 1.5272 1.70206v.00005l.0001.00003.0226.02637 2.3555 2.74816c.2696.3145.2332.788-.0813 1.0575-.3145.2696-.788.2332-1.0575-.0813l-2.3556-2.74817c-.6364-.74245-1.083-1.26244-1.4617-1.6342-.3736-.36672-.626-.53208-.8526-.61348l-.0107-.0038v10.51155c0 .4142-.3358.75-.75.75s-.75-.3358-.75-.75v-10.51155l-.0107.0038c-.2266.0814-.479.24676-.8526.61348-.3787.37176-.8253.89175-1.46169 1.6342l-2.35557 2.74817c-.26956.3145-.74304.3509-1.05753.0813-.3145-.2695-.35092-.743-.08135-1.0575l2.35557-2.74816.0226-.02637c.60856-.70999 1.09684-1.27967 1.52726-1.70214.44087-.43273.87581-.76772 1.39621-.95466zm-6.9822 9.91943c0-.4142-.33579-.75-.75-.75s-.75.3358-.75.75v.2.0321c-.00001.8128-.00001 1.4685.04336 1.9994.04467.5466.13903 1.0267.36537 1.471.35952.7056.9332 1.2792 1.63881 1.6388.44421.2263.92436.3207 1.47099.3653.53091.0434 1.18651.0434 1.99934.0434h.00003.0321 8.4.0321c.8129 0 1.4685 0 1.9994-.0434.5466-.0446 1.0267-.139 1.471-.3653.7056-.3596 1.2792-.9332 1.6388-1.6388.2263-.4443.3207-.9244.3653-1.471.0434-.5309.0434-1.1865.0434-1.9994v-.0321-.2c0-.4142-.3358-.75-.75-.75s-.75.3358-.75.75v.2c0 .8525-.0006 1.4467-.0384 1.9093-.0371.4539-.1062.7147-.2068.9122-.2158.4233-.56.7675-.9833.9833-.1975.1006-.4583.1697-.9122.2068-.4626.0378-1.0568.0384-1.9093.0384h-8.4c-.85245 0-1.44669-.0006-1.90932-.0384-.45387-.0371-.71464-.1062-.91216-.2068-.42336-.2158-.76757-.56-.98328-.9833-.10064-.1975-.16977-.4583-.20686-.9122-.0378-.4626-.03838-1.0568-.03838-1.9093z" /></svg>
                <div><?php echo l('upload-file') ?></div>
            </div>
            <?php } ?>
            <div class="item" @click="login">
                <svg width="22" height="22" viewBox="0 0 24 24"><path d="m8.75001 7c0-1.79493 1.45509-3.25 3.24999-3.25s3.25 1.45507 3.25 3.25-1.4551 3.25-3.25 3.25-3.24999-1.45507-3.24999-3.25zm3.24999-4.75c-2.62334 0-4.74999 2.12665-4.74999 4.75s2.12665 4.75 4.74999 4.75c2.6234 0 4.75-2.12665 4.75-4.75s-2.1266-4.75-4.75-4.75zm-5.6865 16.1524c.98693-2.1566 3.16283-3.6524 5.6865-3.6524 2.5237 0 4.6996 1.4958 5.6865 3.6524.2078.4542.1134.8704-.1871 1.2142-.3195.3656-.873.6334-1.4994.6334h-7.99999c-.6264 0-1.17984-.2678-1.49941-.6334-.30047-.3438-.39492-.76-.1871-1.2142zm5.6865-5.1524c-3.13193 0-5.82838 1.8578-7.05046 4.5282-.48164 1.0525-.22026 2.0911.42167 2.8255.62282.7126 1.59835 1.1463 2.6288 1.1463h7.99999c1.0305 0 2.006-.4337 2.6288-1.1463.642-.7344.9033-1.773.4217-2.8255-1.2221-2.6704-3.9185-4.5282-7.0505-4.5282z" /></svg>
                <div v-if="account"><?php echo l('logout') ?></div>
                <div v-else><?php echo l('login') ?></div>
            </div>
            <a class="item" v-if="account" href="<?php echo URL_BASE ?>main/panel" target="_blank">
                <svg width="22" height="22" viewBox="0 0 24 24"><path d="m12 2.25c-1.5208 0-2.79833 1.14348-2.96627 2.65494l-.0917.82526c-.01543.13888-.11542.30627-.31935.42432-.20104.11638-.39276.11958-.52314.06246l-.7609-.33338c-1.39293-.61029-3.022-.07562-3.78238 1.2414s-.40889 2.9952.81611 3.8963l.66963.4927c.11406.0839.20801.2529.20801.486s-.09395.4021-.20801.486l-.66963.4927c-1.225.9011-1.57649 2.5793-.81611 3.8963s2.38945 1.8517 3.78238 1.2414l.7609-.3334c.13038-.0571.3221-.0539.52314.0625.20393.118.30392.2854.31935.4243l.0917.8253c.16794 1.5114 1.44547 2.6549 2.96627 2.6549s2.7983-1.1435 2.9663-2.6549l.0917-.8253c.0154-.1389.1154-.3063.3193-.4243.2011-.1164.3928-.1196.5232-.0625l.7609.3334c1.3929.6103 3.022.0756 3.7824-1.2414.7603-1.317.4088-2.9952-.8162-3.8963l-.6696-.4927c-.114-.0839-.208-.2529-.208-.486s.094-.4021.208-.486l.6696-.4927c1.225-.9011 1.5765-2.57928.8162-3.8963-.7604-1.31702-2.3895-1.85169-3.7824-1.2414l-.7609.33337c-.1304.05713-.3221.05393-.5232-.06245-.2039-.11805-.3039-.28544-.3193-.42433l-.0917-.82525c-.168-1.51146-1.4455-2.65494-2.9663-2.65494zm-1.4754 2.82059c.0835-.75181.719-1.32059 1.4754-1.32059s1.3919.56878 1.4755 1.32059l.0917.82525c.0781.70365.5289 1.25021 1.0586 1.55686.5335.30881 1.2296.42166 1.8766.13819l.7609-.33337c.6929-.30357 1.5032-.03762 1.8814.61748s.2034 1.48982-.4059 1.93807l-.6696.49263c-.5691.4186-.8192 1.0794-.8192 1.6943s.2501 1.2757.8192 1.6943l.6696.4926c.6093.4483.7841 1.283.4059 1.9381s-1.1885.921-1.8814.6175l-.7609-.3334c-.647-.2835-1.3431-.1706-1.8766.1382-.5297.3067-.9805.8532-1.0586 1.5569l-.0917.8252c-.0836.7518-.7191 1.3206-1.4755 1.3206s-1.3919-.5688-1.4754-1.3206l-.0917-.8252c-.0782-.7037-.529-1.2502-1.05873-1.5569-.53347-.3088-1.2296-.4217-1.87659-.1382l-.76089.3334c-.69286.3035-1.50317.0376-1.88139-.6175-.37823-.6551-.20339-1.4898.40594-1.9381l.66963-.4926c.56902-.4186.81914-1.0794.81914-1.6943s-.25012-1.2757-.81914-1.6943l-.66963-.49263c-.60933-.44825-.78417-1.28297-.40594-1.93807.37822-.6551 1.18853-.92105 1.88139-.61748l.76089.33337c.64699.28347 1.34312.17062 1.87659-.13819.52973-.30665.98053-.85321 1.05873-1.55685zm.2254 6.92941c0-.6904.5597-1.25 1.25-1.25.6904 0 1.25.5596 1.25 1.25s-.5596 1.25-1.25 1.25c-.6903 0-1.25-.5596-1.25-1.25zm1.25-2.75c-1.5188 0-2.74999 1.2312-2.74999 2.75s1.23119 2.75 2.74999 2.75 2.75-1.2312 2.75-2.75-1.2312-2.75-2.75-2.75z" /></svg>
                <div><?php echo l('panel') ?></div>
            </a>
        </div>
    </div>
    <?php if ($open) { ?>
    <!-- 地址栏 -->
    <div class="path" :class="[maskt && 'progress']">
        <a class="item" href="<?php echo URL_BASE ?>" @click="go($event, '')"><?php echo l('file') ?></a>
        <?php foreach ($path as $i => $item) { ?>
        <a class="item removed" href="<?php echo URL_BASE ?>folder/<?php echo $pathKey[$i] ?>"><?php echo $item ?></a>
        <?php } ?>
        <a v-for="item, i of path" class="item" :href="'<?php echo URL_BASE ?>folder/' + pathKey[i]" @click="go($event, pathKey[i])">{{item}}</a>
    </div>
    <!-- 网站介绍 -->
    <div style="padding: 10px 20px 20px 20px;">
        <?php echo $introduce ?>
    </div>
    <!-- 列表 -->
    <div style="padding: 0 20px 20px 20px;" :class="[maskt && 'progress']">
        <div class="table-head">
            <div><?php echo l('name') ?></div>
            <div><?php echo l('create-time') ?></div>
            <div><?php echo l('edit-time') ?></div>
            <div><?php echo l('size') ?></div>
        </div>
        <?php foreach ($list as $item) { ?>
        <div class="table-item removed">
            <div>
            <?php if ($item['type'] === 'folder') { ?>
                <div>
                    <img src="<?php echo STATIC_PATH ?>img/folder.svg" width="28" />
                    <div>
                        <a href="<?php echo URL_BASE ?>folder/<?php echo $item['key'] ?>"><?php echo $item['name'] ?></a>
                        <?php if ($item['note']) { ?><div style="margin-top: 5px; color: var(--tip-color);"><?php echo $item['note'] ?></div><?php } ?>
                    </div>
                </div>
            <? } else { ?>
                <div>
                    <img src="<?php echo STATIC_PATH ?>img/file.svg" width="28" /><a href="<?php echo URL_BASE ?>file/<?php echo $item['key'] ?>"><?php echo $item['name'] ?></a>
                </div>
            <? } ?>
            </div>
            <div><?php echo $item['time_add'] ?></div>
            <div><?php echo $item['time_edit'] ?></div>
            <div><?php echo $item['size'] ?></div>
        </div>
        <?php } ?>
        <div v-for="item of list" class="table-item">
            <div>
                <div v-if="item.type === 'folder'">
                    <img src="<?php echo STATIC_PATH ?>img/folder.svg" width="28" />
                    <div>
                        <a :href="'<?php echo URL_BASE ?>folder/' + item.key" @click="go($event, item.key)">{{item.name}}</a>
                        <div v-if="item.note" style="margin-top: 5px; color: var(--tip-color);" v-html="item.note"></div>
                    </div>
                </div>
                <div v-else>
                    <img src="<?php echo STATIC_PATH ?>img/file.svg" width="28" /><a :href="'<?php echo URL_BASE ?>file/' + item.key" target="_blank">{{item.name}}</a>
                </div>
                <div class="dropdown" @click="openItemMenu($event.currentTarget, item.type, item.name, item.note, item.key)">
                    <svg width="22" height="22" viewBox="0 0 24 24"><path d="m6 10.25c-.9665 0-1.75.7835-1.75 1.75s.7835 1.75 1.75 1.75h.01c.9665 0 1.75-.7835 1.75-1.75s-.7835-1.75-1.75-1.75zm4.25 1.75c0-.9665.7835-1.75 1.75-1.75h.01c.9665 0 1.75.7835 1.75 1.75s-.7835 1.75-1.75 1.75h-.01c-.9665 0-1.75-.7835-1.75-1.75zm6 0c0-.9665.7835-1.75 1.75-1.75h.01c.9665 0 1.75.7835 1.75 1.75s-.7835 1.75-1.75 1.75h-.01c-.9665 0-1.75-.7835-1.75-1.75z" /></svg>
                </div>
            </div>
            <div>{{item.time_add}}</div>
            <div>{{item.time_edit}}</div>
            <div>{{item.size}}</div>
        </div>
    </div>
    <?php } else { ?>
    <div style="flex: 1; justify-content: center; align-items: center; display: flex;">
        <?php echo $closeinfo ?>
    </div>
    <?php } ?>
    <!-- 文件夹/文件 -->
    <div class="menu" :class="[itemMenuShow && 'show']" ref="itemMenu">
        <div class="item" @click="rename">
            <div><?php echo l('rename') ?></div>
        </div>
        <div class="item" @click="move">
            <div><?php echo l('move') ?></div>
        </div>
        <div class="item" @click="remove">
            <div><?php echo l('remove') ?></div>
        </div>
    </div>
    <!-- 上传进度条 -->
    <div class="uploading" :class="[upFiles.length && 'show']">
        <template v-if="upFiles.length">
            <div class="progress" :style="{'width': upFiles[0].per + '%'}"></div>
            <div>{{upFiles[0].name}} ({{upFiles[0].per}}%)</div>
            <div><?php echo l('remaining ? files', ['{{upFiles.length - 1}}']) ?></div>
        </template>
    </div>
</div>
<div style="position:fixed;font-size:12px;right:0;bottom:0;color:rgba(0,0,0,.4);"><?php echo $footer ? $footer . ' - ' : '' ?>Powered by <a href="https://www.maiyun.net" target="_blank">MAIYUN.NET</a> <a href="https://www.maiyun.net/zuny" target="_blank">Zuny</a></div>
</body>
</html>